from Instr import *

class CPU(object):
    def __init__(self, instrs, memory):
        self.ip = 0
        self.mem = memory
        # stack of 253 elements + x and y
        self.stack = [0 for p in range(0,254)]
        self.x = 0
        self.y = 0
        # read counter for reading literals from memory
        self.read_c = 0
        # stash of 15 elements + s
        self.stash = [0 for p in range(0,15)]
        self.s = 0
        self.instrs = dict(zip([i.opcode for i in instrs], instrs))

    def parse(self, inst_opcode):
        #print("cpu.x : ", self.x, "cpu.y : ", self.y," inst_opcode: ", hex(inst_opcode))
        if inst_opcode & 0xF0 == 0x80:
            self.instrs[0x80].opcode = inst_opcode
            self.instrs[0x80].operation(self.instrs[0x80],self)
            self.read_c += 1
            self.read_c %= 4
        else:
            self.instrs[inst_opcode].operation(self.instrs[inst_opcode],self)
            self.read_c = 0
        #print("cpu.x : ", self.x, "cpu.y : ", self.y," inst_opcode: ", hex(inst_opcode))

    def eval_loop(self, end_prog):
        while self.ip < end_prog:
            self.parse(self.mem[self.ip])
            self.ip += 1


    def shift(self,where,what):
        # what = 0 means stack, 1 means stash
        if what == 0:
            # where = 0 means right and 1 means left
            if where == 0:
                for i in range(253,1,-1):
                    self.stack[i] = self.stack[i-1]
                self.stack[0] = self.y
                self.y = self.x
            else:
                self.x = self.y
                self.y = self.stack[0]
                for i in range(0,253):
                    self.stack[i] = self.stack[i+1]
                self.stack[253] = 0
        else:
            if where == 0:
                for i in range(15,1,-1):
                    self.stash[i] = self.stash[i-1]
                self.stash[0] = self.y
                self.y = self.x
            else:
                self.x = self.y
                self.y = self.stash[0]
                for i in range(0,15):
                    self.stash[i] = self.stash[i+1]
                self.stash[15] = 0

