module control_block(OPCODE, L_NIBBLE_NEW, STASH_ENABLE, STASH_OP, ST_XCHG, ST_STICK, ST_OR, ST_RIGHT, ALU_OP);
	input[3:0] OPCODE;
	input L_NIBBLE_NEW;
	output reg STASH_ENABLE;
	output reg STASH_OP;
	output reg ST_XCHG, ST_STICK, ST_OR, ST_RIGHT;
	output reg[2:0] ALU_OP;

	always @(*) begin
		STASH_OP = (OPCODE == 4'h6);
		if((OPCODE == 4'h6) ||
			(OPCODE == 4'hF))
			STASH_ENABLE = 1;
		else 
			STASH_ENABLE = 0;
			
		ST_XCHG = (OPCODE == 0);
		
		if((OPCODE == 4'hA) || 
			(OPCODE == 4'hB) || 
			(OPCODE == 4'hC) || 
			(OPCODE == 4'h8 && !L_NIBBLE_NEW) ||
			(OPCODE == 0)) 
			ST_STICK = 1;
		else 
			ST_STICK = 0;
		
		if((OPCODE == 4'h6) || 
			(OPCODE == 4'h7) || 
			(OPCODE == 4'h9) || 
			(OPCODE == 0)) 
			ST_OR = 1;
		else if(OPCODE == 4'h8)
			ST_OR = !L_NIBBLE_NEW;
		else
			ST_OR = 0;
			
		if((OPCODE == 4'hE) || 
			(OPCODE == 4'hF) ||
			(OPCODE == 4'h8 && L_NIBBLE_NEW))
			ST_RIGHT = 1;
		else 
			ST_RIGHT = 0;
		
		if(OPCODE <= 5) ALU_OP = OPCODE[2:0];
		else if(OPCODE == 4'hA) ALU_OP = 6;
		else if(OPCODE == 4'hB) ALU_OP = 7;
		else ALU_OP = 0;
	end
endmodule
