module stack(CLK, IN, X, Y, OP);
	input CLK;
	input[15:0] IN;
	input[3:0] OP;
	output[15:0] X;
	output[15:0] Y; 
	wire XCHG; 	// 1: exchange X and Y
	wire STICK;	// 1: do not move stack
	wire OR;   	// 1: bitwise-or X with IN
					// 0: overwrite X with IN
	wire RIGHT;	// 1: shift right
					// 0: shift left
	assign {XCHG, STICK, OR, RIGHT} = OP;
	reg[15:0] data[255:0];
	reg[15:0] xtmp;
	integer i;
	
	assign X = data[0];
	assign Y = data[1];
	
	always@(negedge CLK) begin
		if(XCHG) begin
			xtmp = Y;
			data[1] = X;
			data[0] = xtmp;
		end else begin
			if(!STICK) begin
				if(RIGHT == 1) begin
					for(i=255; i>0; i = i-1) data[i]=data[i-1];
					if(OR) data[0] = X|IN;
					else data[0] = IN;
				end else begin
					if(OR) data[0] = Y|IN;
					else data[0] = IN;
					for(i=1; i<255; i = i+1) data[i]=data[i+1];
					data[255] = 0;
				end
			end else begin
				if(OR) data[0] = X|IN;
				else data[0] = IN;
			end
		end
	end 
endmodule
